﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication1
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}

		private void Form1_Load(object sender, EventArgs e)
		{
            //MyEditorWithMask editor = new MyEditorWithMask();
            //ultraGrid2.DisplayLayout.Bands[0].Columns["Age"].Editor = editor;

			List<JOJO> jojos = new List<JOJO>(){ new JOJO(){ Name = "JOJO", Age = 10, DateOfBirth = new DateTime(2009, 03,01)}, new JOJO(){ Name = "JAJA", Age = 15, DateOfBirth = new DateTime(2009, 12, 31)}};
			ultraGrid2.DataSource = jojos;
		}

        private void ultraGrid2_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            UltraGridBand band0 = e.Layout.Bands[0];

            // Hide the "real" age column. 
            band0.Columns["Age"].Hidden = true;

            // Add a new unbound age column in the same positon and with the same caption as the 
            // Age column. 
            //
            if (band0.Columns.Exists("Unbound Age") == false)
            {
                UltraGridColumn unboundAgeColumn = band0.Columns.Add("Unbound Age");
                unboundAgeColumn.DataType = band0.Columns["Age"].DataType;
                unboundAgeColumn.Header.Caption = band0.Columns["Age"].Header.Caption;
                unboundAgeColumn.Header.VisiblePosition = band0.Columns["Age"].Header.VisiblePosition;
            }
        }

        private void ultraGrid2_InitializeRow(object sender, InitializeRowEventArgs e)
        {            
            UltraGridBand band = e.Row.Band;

            // Copy the value from the hidden Age column into the unbound age (visible) column
            // times 10. 
            if (band.Columns.Exists("Unbound Age"))
            {
                e.Row.Cells["Unbound Age"].Value = (int)e.Row.Cells["Age"].Value * 10;
            }
        }

        private void ultraGrid2_AfterCellUpdate(object sender, CellEventArgs e)
        {
            // Whenever the Unbound Age column is updated, set the value of the real
            // Age column to the new value divided by 10. 
            if (e.Cell.Column.Key == "Unbound Age")
                e.Cell.Row.Cells["Age"].Value = (int)e.Cell.Value / 10;
        }
	}

	public class JOJO
	{
		public string Name {get; set;}

		private int age;
		public int Age
		{
			get
			{
				return age;
			}
			set
			{
				age = value;
			}
		}


		public DateTime DateOfBirth { get; set; }

		public JOJO()
		{
		}
	}
}
